# Antora Index Asciidoctor Extension
:version: 0.0.2

This is an Asciidoctor extension for Antora, having two blockMacro processors and two inlineMacro processors.

* indexList blockMacro processor produces a list of xrefs to selected content catalog pages.
* indexTable blockMacro processor adds to a preceding table rows constructed from xrefs to content catalog pages and attributes of those pages.
* indexCount inlineMacro processor counts the pages selected by the criteria.
* indexUniqueCount inlineMacro processor counts the unique values of the specified attribute in the pages selected by the criteria.

One way to view the philosophy behind this extension is that the combination of the Antora project structure and page attributes form a database, so it is natural to query this database.
This extension provides some query facilities.
Perhaps it is most likely to be useful in sections that consist of non-sequential pages documenting equivalent features.
For example if a system consists of a core framework together with a number of extensions, this could index the extensions.

The git repository for this extension is https://gitlab.com/djencks/asciidoctor-antora-indexer.

For reasonably complete instructions, consult https://gitlab.com/djencks/asciidoctor-antora-indexer.
Due to the limitations of markdown, there is no attempt to provide details here.

## Installation

Available through npm as @djencks/asciidoctor-antora-indexer.

The simplest way to install this is through a package.json file next to your Antora playbook.

Configure this as an asciidoctor extension in your playbook.

## Configuration

### Common Configuration of selected pages

All four processors are configured similarly to select pages to index.
All selected pages are ordered by case-insensitive doctitle.
The current page is always excluded from the list of indexed pages.
All processors use the "short" form in which the macro name is immediately followed by configuration in square brackets.


### indexList Block Processor

This block processor is used freestanding or in an existing list or sublist.


### indexTable Block Processor

This block processor is used to add rows to a table whose cell contents are attribute values of the selected pages.


### indexCount Inline Macro Processor

This inline processor counts the pages matching the criteria.
There are no parameters beyond the filter.

### indexUniqueCount Inline Macro Processor

This inline macro processor counts the unique values of the specified attribute in the pages matching the criteria.

## Examples

A small example project is in the link:https://gitlab.com/djencks/simple-examples[Simple Examples] project at extensions/index-extension.
